config/routes.rb
Dairymen::Application.routes.draw do

  resources :plans

  resources :shifts

  resources :stalls

  resources :kine do
    resources :seminations
    resources :estruses
  end

  root :to => 'kine#index'

end

app/models/shift.rb
class Shift < ActiveRecord::Base
  belongs_to :cow
  belongs_to :stall
end

app/controllers/shifts_controller.rb
class ShiftsController < ApplicationController
  # GET /shifts
  # GET /shifts.json
  def index
    @search = Shift.search params[:search]
    @shifts = @search.page params[:page]

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @shifts }
    end
  end

  # GET /shifts/1
  # GET /shifts/1.json
  def show
    @shift = Shift.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @shift }
    end
  end

  # GET /shifts/new
  # GET /shifts/new.json
  def new
    @shift = Shift.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @shift }
    end
  end

  # GET /shifts/1/edit
  def edit
    @shift = Shift.find(params[:id])
  end

  # POST /shifts
  # POST /shifts.json
  def create
    @shift = Shift.new(params[:shift])

    respond_to do |format|
      if @shift.save
        format.html { redirect_with_notice @shift, :shifted }
        format.json { render json: @shift, status: :created, location: @shift }
      else
        format.html { render action: "new" }
        format.json { render json: @shift.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /shifts/1
  # PUT /shifts/1.json
  def update
    @shift = Shift.find(params[:id])

    respond_to do |format|
      if @shift.update_attributes(params[:shift])
        format.html { redirect_with_notice @shift, :updated }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @shift.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /shifts/1
  # DELETE /shifts/1.json
  def destroy
    @shift = Shift.find(params[:id])
    @shift.destroy

    respond_to do |format|
      format.html { redirect_to shifts_url }
      format.json { head :ok }
    end
  end
end

app/helpers/shifts_helper.rb
module ShiftsHelper
end

app/views/shifts/_form.html.haml
= simple_form_for @shift do |form|

  -if @shift.errors.any?
    #errorExplanation
      %h2= "#{pluralize(@shift.errors.count, "error")} prohibited this #{Shift.name.titleize} from being saved:"
      %ul
        - @shift.errors.full_messages.each do |msg|
          %li= msg  

  = form.association :cow, :label_method => lambda{|x| x.ear_tag}
  = form.association :stall
  = form.input :date

  .actions
    = form.button :submit

app/views/shifts/edit.html.haml
%h1= t ".editing_shift"

= render 'form'

= link_to t('.show'), @shift
\|
= link_to t('.back'), shifts_path

app/views/shifts/index.html.haml
%h1= t ".listing_shifts"

= simple_form_for @search do |f|
  = f.input :cow_ear_tag_contains, :required => false
  = f.input :stall_name_contains, :required => false
  = f.input :date_gte, :as => :date, :required => false, :use_era_name => true, :start_year => Date.today.year - 10, :include_blank => true
  = f.input :date_lte, :as => :date, :required => false, :use_era_name => true, :start_year => Date.today.year - 10, :include_blank => true
  = f.submit :search


%table
  %tr
    %th= sort_link @search, :cow_ear_tag
    %th= sort_link @search, :stall_seq
    %th= sort_link @search, :date
    %th
    %th
    %th

  - @shifts.each do |shift|
    %tr
      %td= shift.cow.ear_tag
      %td= shift.stall.name
      %td= shift.date
      %td= link_to t(".show"), shift
      %td= link_to t(".edit"), edit_shift_path(shift)
      %td= link_to t(".destroy"), shift, :confirm => 'Are you sure?', :method => :delete

%br

= link_to t(".new_shift"), new_shift_path

app/views/shifts/new.html.haml
%h1= t ".new_shift"

= render 'form'

= link_to t('.back'), shifts_path

app/views/shifts/show.html.haml
%h1= t ".show_shift"
%p#notice= notice

%p
  %b= t ".cow"
  = @shift.cow.ear_tag
%p
  %b= t ".stall"
  = @shift.stall.name
%p
  %b= t ".date"
  = l @shift.date

= link_to t('.edit'), edit_shift_path(@shift)
\|
= link_to t('.back'), shifts_path